import sys

# nom_script, gaf_grannot, gaf_aligner
if not(len(sys.argv)==3) :
        print("expected input : gaf file from grannot, gaf file of the gene alignment on the graph")
        sys.exit(1)
elif (sys.argv[1]=="-h") :
    print("expected input : gaf file from grannot, gaf file of the gene alignment on the graph")
    sys.exit(1)

[gaf_file_grannot,gaf_file_aligner]=[sys.argv[1],sys.argv[2]]

gaf_grannot=open(gaf_file_grannot,"r");gaf_lines_grannot=gaf_grannot.readlines();gaf_grannot.close()

walks_grannot={}
for line in gaf_lines_grannot:
        feature_id=line.split()[0]
        seg=line.split()[5] # get segments field and split it
        segments=seg.replace('<',',<').replace('>',',>').split(',')[1:]
        start=line.split()[7]
        stop=line.split()[8]

        walks_grannot[feature_id]=[segments,start,stop]






gaf_aligner=open(gaf_file_aligner,"r");gaf_lines_aligner=gaf_aligner.readlines();gaf_aligner.close()

feat_found_aln={}
for line in gaf_lines_aligner:
        feature_id=line.split()[0].split(";")[0].split('=')[1]
        seg=line.split()[5] # get walk field
        segments=seg.replace('<',',<').replace('>',',>').split(',')[1:] # make list from walk field
        start=line.split()[7]
        stop=line.split()[8]

        if feature_id not in feat_found_aln:
                feat_found_aln[feature_id]=[[segments,start,stop]]
        else:
               feat_found_aln[feature_id].append([segments,start,stop])



seg_ok=0
seg_no=0
start_ok=0
start_no=0
stop_ok=0
stop_no=0
feat_not_in_aln=0


for feature_id in walks_grannot:

        if feature_id not in feat_found_aln:
                feat_not_in_aln+=1
        else:
                best_occurence=feat_found_aln[feature_id][0]
                score=0
                score_max=0
                if len(feat_found_aln[feature_id])>1:
                        # find best score, then check best occurence
                        grannot_seg_list=walks_grannot[feature_id][0]
                        for occurence in feat_found_aln[feature_id]:
                                for segment_aln in occurence[0]: # find the occurence with the most segments in common with grannot walk
                                        if segment_aln in grannot_seg_list:
                                                score+=1
                                if score>score_max:
                                        score_max=score
                                        best_occurence=occurence


                for seg_aligner in walks_grannot[feature_id][0]:
                        if seg_aligner in best_occurence[0]:
                                seg_ok+=1
                        else:
                                seg_no+=1
                if best_occurence[1]==walks_grannot[feature_id][1]: # todo : only if the first seg is the same !
                        start_ok+=1
                else:
                        start_no+=1
                if best_occurence[2]==walks_grannot[feature_id][2]: # todo : only if the last seg is the same ! 
                        stop_ok+=1
                else:
                        stop_no+=1
                

print(feat_not_in_aln)
print(seg_ok,seg_no) # segments from grannot found in the gene in aligner or not
print(start_ok,start_no) # same start pos or not
print(stop_ok,stop_no) # same stop pos or not