check_dupl=False
if check_dupl:
    print("build a dictionnary with the segment sizes")
    segments_file = open('seg_coord/segments.txt','r')
    lines=segments_file.readlines()
    segments_file.close()
    seg_size={}

    for line in lines:
        line=line.split()
        seg_id='s'+line[1]
        segment_size=len(line[2])
        seg_size[seg_id]=segment_size

    print("nb segments dans le graphe : ",len(seg_size))

    print("read the paths and store the segments in a dict")
    segments = open('../test_all_genomes/seg_coord/walks.txt','r')
    lines=segments.readlines()
    segments.close()
    dict={} # store sthe segments met in the walks
    for line in lines :
        line=line.split()
        name=line[1]+"_"+line[3]
        if ("MINIGRAPH" not in name) and ("IRGSP" not in name): 
            path_start=int(line[4])
            seq_name=line[3]
            dict[seq_name]={}
            path=line[6].split(',')
            for i in range(1, len(path)): # for each segment in the path, write the position of the segment in the output bed file
                seg_name=path[i]
                if seg_name not in dict[seq_name]:
                    dict[seq_name][seg_name]=list()
                    dict[seq_name][seg_name].append(seg_name)
                else:
                    dict[seq_name][seg_name].append(seg_name)

    print("count the duplications")
    list_nb_segments=[]
    nb_seg_conc=0
    seg_total=0
    seg_dupl_len=list()
    all_seg_len=list()
    segments_met={}
    segments_dupl_met={}
    f = open('doublons_segments.txt','w')
    for walk in dict:
        for segment_id in dict[walk]:
            seg_total+=1
            segment_list=dict[walk][segment_id]
            segment='s'+segment_list[0][1:]
            if segment not in segments_met:
                all_seg_len.append(seg_size[segment])
                segments_met[segment]=True
            if len(segment_list)>1:
                line=walk+"\t"+segment+"\n"
                f.write(line)
                if len(segment_list) not in list_nb_segments:
                    list_nb_segments.append(len(segment_list))
                if segment not in segments_dupl_met:
                    seg_dupl_len.append(seg_size[segment])
                    segments_dupl_met[segment]=True
                nb_seg_conc+=1
    from statistics import mean
    print(list_nb_segments,nb_seg_conc,seg_total,mean(seg_dupl_len),mean(all_seg_len)) # list of number of copies found, how many segments are present at least twice in a walk, number of segments total.

    # print("plot the repartitions of the segments length (duplicated segments or all segments)")
    # import seaborn as sns
    # import matplotlib.pyplot as plt
    # import pandas as pd

    # sns.set_theme(style="darkgrid")
    # sns
    # data_dupl = {'seg_len': seg_dupl_len}
    # df_dupl = pd.DataFrame(data_dupl)
    # sns.histplot(data=df_dupl, x="seg_len")
    # plt.show()


    # data too big, crashes the computer ?

    # sns.set_theme(style="darkgrid")
    # sns
    # data_all = {'seg_len': all_seg_len}
    # df_all = pd.DataFrame(data_all)
    # sns.histplot(data=df_all, x="seg_len")
    # plt.show()


compare_gff=False
if compare_gff:
    new = open('Os117425RS1/Os117425RS1.gff','r')
    lines_new=new.readlines()
    new.close()
    dict_genes_new={}
    for line in lines_new:
        line=line.split()
        gene_id=line[8].split(';')[0]
        if gene_id not in dict_genes_new:
            dict_genes_new[gene_id]=[line[0]]
        else:
            dict_genes_new[gene_id].append(line[0])


    old = open('Os117425RS1/Os117425RS1_genes_old.gff','r')
    lines_old=old.readlines()
    old.close()
    dict_genes_old={}
    for line in lines_old:
        line=line.split()
        gene_id=line[8].split(';')[0]
        if gene_id not in dict_genes_old:
            dict_genes_old[gene_id]=[line[0]]
        else:
            dict_genes_old[gene_id].append(line[0])

    for gene in dict_genes_new:
        if gene in dict_genes_old:
            if len(dict_genes_new[gene])!=len(dict_genes_old[gene]):
                print("len diff : new,old,gene_id :",len(dict_genes_new[gene]),len(dict_genes_old[gene]),gene)
        else:
            print("gene from new missing from old ",gene)
    print("\n")
    for gene in dict_genes_old:
        if gene not in dict_genes_new:
            print("gene from new missing from new ",gene)

    print("len of both dict: ",len(dict_genes_new),len(dict_genes_old))


stat_var_by_feature=False
if stat_var_by_feature:
    var_file = open('Azucena_var.txt','r')
    lines_var=var_file.readlines()
    var_file.close()
    dict_var={} # feature_id -> [type,length,ins_count,del_count_subs_count]
    
    for line in lines_var:
        var=line.split()
        feature_id=var[0]

        if feature_id not in dict_var:
            feature_type=var[1]
            feature_size_new=int(var[5])
            feature_size_diff=int(var[7])
            feature_size=feature_size_new+feature_size_diff
            dict_var[feature_id]=[feature_type,feature_size,0,0,0]
        
        var_type=var[8]
        if var_type=="insertion":
            dict_var[feature_id][2]+=1
        elif var_type=="deletion":
            dict_var[feature_id][3]+=1
        elif var_type=="substitution":
            dict_var[feature_id][4]+=1

    # calculate the rates. 
    # total exon/... length + total exon/... subs/del/ins
    gene_info=[0,0,0,0] # gene_total_length,gene_total_ins,gene_total_del,gene_total_subs
    mrna_info=[0,0,0,0]
    cds_info=[0,0,0,0]
    utr3_info=[0,0,0,0]
    utr5_info=[0,0,0,0]
    exon_info=[0,0,0,0]
    intron_info=[0,0,0,0]

    for feature in dict_var:
        feature_info=dict_var[feature] # feature_id -> [type,length,ins_count,del_count_subs_count]
        feature_type=feature_info[0]
        match feature_type:
            case "gene":
                gene_info[0]+=feature_info[1]
                gene_info[1]+=feature_info[2]
                gene_info[2]+=feature_info[3]
                gene_info[3]+=feature_info[4]
            case "mRNA":
                mrna_info[0]+=feature_info[1]
                mrna_info[1]+=feature_info[2]
                mrna_info[2]+=feature_info[3]
                mrna_info[3]+=feature_info[4]
            case "CDS":
                cds_info[0]+=feature_info[1]
                cds_info[1]+=feature_info[2]
                cds_info[2]+=feature_info[3]
                cds_info[3]+=feature_info[4]
            case "five_prime_UTR":
                utr5_info[0]+=feature_info[1]
                utr5_info[1]+=feature_info[2]
                utr5_info[2]+=feature_info[3]
                utr5_info[3]+=feature_info[4]
            case "three_prime_UTR":
                utr3_info[0]+=feature_info[1]
                utr3_info[1]+=feature_info[2]
                utr3_info[2]+=feature_info[3]
                utr3_info[3]+=feature_info[4]
            case "exon":
                exon_info[0]+=feature_info[1]
                exon_info[1]+=feature_info[2]
                exon_info[2]+=feature_info[3]
                exon_info[3]+=feature_info[4]
            case "intron":
                intron_info[0]+=feature_info[1]
                intron_info[1]+=feature_info[2]
                intron_info[2]+=feature_info[3]
                intron_info[3]+=feature_info[4]
    
    
    # exon_subs/exon_length
    # print all.
    print(len(dict_var))
    print("gene",gene_info[1]/gene_info[0],gene_info[2]/gene_info[0],gene_info[3]/gene_info[0])
    print("mrna",mrna_info[1]/mrna_info[0],mrna_info[2]/mrna_info[0],mrna_info[3]/mrna_info[0])
    print("cds",cds_info[1]/cds_info[0],cds_info[2]/cds_info[0],cds_info[3]/cds_info[0])
    print("5'utr",utr5_info[1]/utr5_info[0],utr5_info[2]/utr5_info[0],utr5_info[3]/utr5_info[0])
    print("3'utr",utr3_info[1]/utr3_info[0],utr3_info[2]/utr3_info[0],utr3_info[3]/utr3_info[0])
    print("exon",exon_info[1]/exon_info[0],exon_info[2]/exon_info[0],exon_info[3]/exon_info[0])
    print("intron",intron_info[1]/intron_info[0],intron_info[2]/intron_info[0],intron_info[3]/intron_info[0])


test_cecile=False
if test_cecile:
    print("")
    seg_cent={}
    with open('seg_centromeres_irgsp','r') as seg_centromere:
        line=seg_centromere.readline()
        while line:
            line=line.split()
            seg_id=line[3][1:]
            seg_cent[seg_id]=line[3][0]
            line=seg_centromere.readline()

    seg_common=[]
    with open('full_azucena','r') as seg_azu:
        line=seg_azu.readline()
        while line:
            line=line.split()
            seg_id=line[3][1:]
            if seg_id in seg_cent:
                seg_common.append(seg_id)
            line=seg_azu.readline()
    print(len(seg_common))

    
#import subprocess
#output =  subprocess.Popen("wc -l seg_coord/walks.txt", shell=True, stdout=subprocess.PIPE).stdout.read().decode()
#print(output.split()[0])


test_transloc=False

if test_transloc:
    file = open("test_compare_70",'r')
    lines=file.readlines()
    file.close()

    convert_chr={}
    convert_chr["CM020633.1"]="01"
    convert_chr["CM020634.1"]="02"
    convert_chr["CM020635.1"]="03"
    convert_chr["CM020636.1"]="04"
    convert_chr["CM020637.1"]="05"
    convert_chr["CM020638.1"]="06"
    convert_chr["CM020639.1"]="07"
    convert_chr["CM020640.1"]="08"
    convert_chr["CM020641.1"]="09"
    convert_chr["CM020642.1"]="10"
    convert_chr["CM020643.1"]="11"
    convert_chr["CM020644.1"]="12"

    same_chr=0
    diff_chr=0
    other_chr=0
    cov_same=[]
    id_same=[]
    cov_diff=[]
    id_diff=[]

    transpo_same=0
    not_transpo_same=0
    transpo_diff=0
    not_transpo_diff=0

    for line in lines:
        line=line.split()
        chrom=line[0]
        feat=line[8].split(";")[0].split("=")[1]
        feat_chr=feat.split("s")[1].split("g")[0]
        cov=float(line[8].split(';')[3].split('=')[1])
        id=float(line[8].split(';')[4].split('=')[1])

        if chrom not in convert_chr:
            other_chr+=1
            if 'ranspo' in line[8]:
                transpo_diff+=1
            else:
                not_transpo_diff+=1
        else:
            if feat_chr!=convert_chr[chrom]:
                diff_chr+=1
                cov_diff.append(cov)
                id_diff.append(id)
                if 'ranspo' in line[8]:
                    transpo_diff+=1
                else:
                    not_transpo_diff+=1
            else:
                same_chr+=1
                cov_same.append(cov)
                id_same.append(id)
                if 'ranspo' in line[8]:
                    transpo_same+=1
                else:
                    not_transpo_same+=1

    print("diff",diff_chr,sum(cov_diff)/len(cov_diff),sum(id_diff)/len(id_diff))
    print("transpo rate",transpo_diff/(transpo_diff+not_transpo_diff))
    print("same",same_chr,sum(cov_same)/len(cov_same),sum(id_same)/len(id_same))
    print("transpo rate",transpo_same/(transpo_same+not_transpo_same))
    print(other_chr)
    print("total transpo rate",(transpo_diff+transpo_same)/(not_transpo_same+not_transpo_diff+transpo_diff+transpo_same))





rename_paths_gfa_human=False
if rename_paths_gfa_human:
    from tqdm import tqdm
    new_gfa=open('/home/nina/grannot/GrAnnoT/wd/test_data/humain/chr1_new.gfa','w')
    gfa_open=open('/home/nina/grannot/GrAnnoT/wd/test_data/humain/chr1.gfa','r')
    for line in tqdm(gfa_open, desc="read gfa", unit=" line",total=16123936):
        if line[0]=='P':
            if "MINIGRAPH" not in line.split()[1]:
                first_index=line.index('.')
                line_temp=line[0:first_index]+'#'+line[first_index+1:]
                if line.split()[1]!="GRCh38.chr1":
                    second_index=line_temp.index('.')
                    new_line=line_temp[0:second_index]+'#'+line_temp[second_index+1:]
                    
                else:
                    new_line=line_temp[0:first_index]+'#0#'+line[first_index+1:]
                new_gfa.write(new_line)
        else:
            new_gfa.write(line)

    gfa_open.close()
    new_gfa.close()



remove_frag_human_gff=False
if remove_frag_human_gff:
    with open("/home/nina/grannot/GrAnnoT/wd/test_data/humain/CHM13_chr1.gff") as human_gff, open("test_human_gff",'w') as output:
        dict_feat={}
        for line in human_gff:
            feat_id=line.split()[8].split(";")[0].split('=')[1]
            if feat_id not in dict_feat:
                dict_feat[feat_id]=list()
                dict_feat[feat_id].append("a")
                output.write(line)
            else:
                feat_id_new=feat_id+"_"+str(len(dict_feat[feat_id]))
                dict_feat[feat_id].append("a")
                new_line=line.replace(feat_id,feat_id_new)
                output.write(new_line)


odgi_transfer=False
if odgi_transfer:
    odgi_path="/home/nina/soft/odgi_vg_full_graph_gff/odgi/test_odgi_full"
    bed_annot_path="/home/nina/soft/odgi_vg_full_graph_gff/nb_allFeatures_renamed_filter.bed"
    with open(odgi_path) as odgi_file, open(bed_annot_path) as bed_file:
        feat_odgi={}
        for line in odgi_file:
            feat_id=line.split()[8].split(";")[0].split("=")[1]
            if feat_id in feat_odgi:
                print("doublon :",feat_id)
            else:
                feat_odgi[feat_id]=''
        unmapped=0
        for line in bed_file:
            feat_id=line.split()[8].split(";")[0].split("=")[1]
            if feat_id not in feat_odgi:
                print("feat in input file not in odgi, unmapped :",feat_id)
                unmapped+=1
    print(unmapped)

double_transfer_loss=False
if double_transfer_loss:
    annot_input_path="/home/nina/grannot/GrAnnoT/wd/test_data/rice_chr10/test_double_transfert/liftoff_transfers/nb_allFeatures.gff3"
    liftoff_first_transfer_path="/home/nina/grannot/GrAnnoT/wd/test_data/rice_chr10/test_double_transfert/liftoff_transfers/NbToAzu.gff3"
    liftoff_second_transfer_path="/home/nina/grannot/GrAnnoT/wd/test_data/rice_chr10/test_double_transfert/liftoff_transfers/AzuToNb.gff3"
    grannot_first_transfer_path="/home/nina/grannot/GrAnnoT/wd/test_data/rice_chr10/test_double_transfert/grannot_transfers/full_graph/premier_transfer/Azucena/Azucena.gff"
    grannot_second_transfer_path="/home/nina/grannot/GrAnnoT/wd/test_data/rice_chr10/test_double_transfert/grannot_transfers/full_graph/deuxieme_transfer/IRGSP/IRGSP.gff"
    
    with open(liftoff_first_transfer_path) as liftoff_first:
        liftoff_first_dict={}
        for line in liftoff_first:
            if (line[0]!="#") and (line.split()[2]=="gene"):
                feat_id=line.split()[8].split(';')[0].split("=")[1]
                liftoff_first_dict[feat_id]=''

    with open(liftoff_second_transfer_path) as liftoff_second:
        liftoff_second_dict={}
        for line in liftoff_second:
            if (line[0]!="#") and (line.split()[2]=="gene"):
                feat_id=line.split()[8].split(';')[0].split("=")[1]
                liftoff_second_dict[feat_id]=''

    with open(grannot_first_transfer_path) as grannot_first:
        grannot_first_dict={}
        for line in grannot_first:
            if (line[0]!="#") and (line.split()[2]=="gene"):
                feat_id=line.split()[8].split(';')[0].split("=")[1]
                grannot_first_dict[feat_id]=''

    with open(grannot_second_transfer_path) as grannot_second:
        grannot_second_dict={}
        for line in grannot_second:
            if (line[0]!="#") and (line.split()[2]=="gene"):
                feat_id=line.split()[8].split(';')[0].split("=")[1]
                grannot_second_dict[feat_id]=''


    with open(annot_input_path) as annot_input:
        loss_first_liftoff=0
        loss_first_grannot=0
        for line in annot_input:
            if line.strip():
                if (line[0]!="#") and (line.split()[2]=="gene"):
                    feat_id=line.split()[8].split(';')[0].split("=")[1]
                    if feat_id not in liftoff_first_dict:
                        loss_first_liftoff+=1
                    if feat_id not in grannot_first_dict:
                        loss_first_grannot+=1
    
    loss_second_liftoff=0
    for feat in liftoff_first_dict:
        if feat not in liftoff_second_dict:
            loss_second_liftoff+=1
    loss_second_grannot=0
    for feat in grannot_first_dict:
        if feat not in grannot_second_dict:
            loss_second_grannot+=1

    print("loss liftoff:",loss_first_liftoff,loss_second_liftoff)
    print("loss grannot:",loss_first_grannot,loss_second_grannot)



