import sys

if not(len(sys.argv)==3) :
        print("expected input : two gff files, origin and new")
        sys.exit(1)
elif (sys.argv[1]=="-h") :
    print("expected input : two gff files, origin and new")
    sys.exit(1)

annot_file=sys.argv[1]
transfer_file=sys.argv[2]


# build a dictionnary with the tool transfer

transfer = open(transfer_file,'r')
lines=transfer.readlines()
transfer.close()

transfer_gff={}
transpo=0
non_transpo=0
for line in lines:
    if line.strip():
        if (line[0]!="#") and (line.split()[2]=="gene"):
            line=line.split()
            feature=line[8].split(';')[0].split('=')[1]
            chr=line[0]
            start=int(line[3])
            stop=int(line[4])
            # cov=float(line[8].split(';')[-2].split('=')[1])
            # id=float(line[8].split(';')[-1].split('=')[1])
            pos=list([chr,start,stop])
            # if feature in transfer_gff:
            #     if cov+id>transfer_gff[feature][3]+transfer_gff[feature][4]:
            #         transfer_gff[feature]=pos
            # else:
            transfer_gff[feature]=pos # feat_id -> [chr, start, stop, cov, seq_id]

print(len(transfer_gff),"features found in transfer gff")



# build a dictionnary with the annot alignements

annot = open(annot_file,'r')
lines=annot.readlines()
annot.close()

annot_gff={}
for line in lines:
    if line.strip():
        if (line[0]!="#") and (line.split()[2]=="gene"):
            line=line.split()
            feature=line[8].split(';')[0].split('=')[1]
            chr=line[0]
            start=int(line[3])
            stop=int(line[4])
            pos=list([chr,start,stop])
            annot_gff[feature]=pos # feat_id -> [chr, start, stop, cov, seq_id]

            #if feature not in transfer_gff:
            #    print("\t".join(line))

print(len(annot_gff), "features originaly in the annotation")




# intersection between the two transfers :
common=list();only_annot=list();only_transfer=list()
for feat_annot in annot_gff:
    if feat_annot in transfer_gff:
        if feat_annot not in common:
            common.append(feat_annot)
    else:
        only_annot.append(feat_annot)

for feat_transfer in transfer_gff:
    if feat_transfer in annot_gff:
        if feat_transfer not in common:
            common.append(feat_transfer)
    else:
        only_transfer.append(feat_transfer)

print(len(common),"features found in transfer gff and the origin gff")
print(len(only_annot),"features not found, only in origin gff")
print(len(only_transfer),"features new, only in transfer gff (weird)\n")


# common transfers
[diff_chr,same_pos,diff_pos,close,close_ish,close_ishish,not_close,dist]=[0,0,0,0,0,0,0,[]]
diff_pos_list=[]
list_diff_pos=list()
for feat in common:
    if annot_gff[feat][0]==transfer_gff[feat][0]: # check if same chromosome 
        dist.append(abs(annot_gff[feat][1]-transfer_gff[feat][1])+abs(annot_gff[feat][2]-transfer_gff[feat][2]))
        if (annot_gff[feat][1]==transfer_gff[feat][1]) & (annot_gff[feat][2]==transfer_gff[feat][2]): # exact same position
            same_pos+=1
        else: 
            diff_pos+=1;diff_pos_list.append([feat,abs(annot_gff[feat][1]-transfer_gff[feat][1])+abs(annot_gff[feat][2]-transfer_gff[feat][2])])
            if (abs(annot_gff[feat][1]-transfer_gff[feat][1])<10) & (abs(annot_gff[feat][2]-transfer_gff[feat][2])<10): # start and stop close
                close+=1
            elif (abs(annot_gff[feat][1]-transfer_gff[feat][1])<50) & (abs(annot_gff[feat][2]-transfer_gff[feat][2])<100): # start and stop not to far
                close_ish+=1
            elif (abs(annot_gff[feat][1]-transfer_gff[feat][1])<100) & (abs(annot_gff[feat][2]-transfer_gff[feat][2])<1000): # start and stop quite far
                close_ishish+=1
            else:
                not_close+=1

    else:
        diff_chr+=1



print(same_pos,"features are at the exact same position before and after the double transfer")
print(diff_pos+diff_chr,"features are not in the exact same position before and after the double transfer. Among those :")
print(close,"have their start and stop positions less than 10 bases away")
print(close_ish,"have their start and stop positions between 11 and 100 bases away")
print(close_ishish,"have their start and stop positions between 101 and 1000 bases away")
print(not_close,"have their start and stop positions more that 1000 bases away")
print(diff_chr,"are not on the same chromosome\n")

#print(diff_pos_list) # list of [feat_name, position difference], for all the features that are not at the same position before and after the double transfer.

