import sys

# nom_script, gaf_grannot, gaf_aligner
if not(len(sys.argv)==3) :
        print("expected input : gaf file from grannot, gaf file of the gene alignment on the graph")
        sys.exit(1)
elif (sys.argv[1]=="-h") :
    print("expected input : gaf file from grannot, gaf file of the gene alignment on the graph")
    sys.exit(1)

[gaf_file_grannot,gaf_file_aligner]=[sys.argv[1],sys.argv[2]]

gaf_grannot=open(gaf_file_grannot,"r");gaf_lines_grannot=gaf_grannot.readlines();gaf_grannot.close()

walks_grannot={}
for line in gaf_lines_grannot:
        if ';' in line.split()[0]:
                feature_id=line.split()[0].split(";")[0].split('=')[1]
        else:
                feature_id=line.split()[0]
       
        seg=line.split()[5] # get segments field and split it
        segments=seg.replace('<',',<').replace('>',',>').split(',')[1:]
        start=line.split()[7]
        stop=line.split()[8]

        walks_grannot[feature_id]=[segments,start,stop]






gaf_aligner=open(gaf_file_aligner,"r");gaf_lines_aligner=gaf_aligner.readlines();gaf_aligner.close()

feat_found_aln={}
for line in gaf_lines_aligner:
        if ';' in line.split()[0]:
                feature_id=line.split()[0].split(";")[0].split('=')[1]
        else:
                feature_id=line.split()[0]
        seg=line.split()[5] # get walk field
        segments=seg.replace('<',',<').replace('>',',>').split(',')[1:] # make list from walk field
        start=line.split()[7]
        stop=line.split()[8]

        if feature_id not in feat_found_aln:
                feat_found_aln[feature_id]=[[segments,start,stop]]
        else:
               feat_found_aln[feature_id].append([segments,start,stop])



seg_ok=0
seg_no=0
start_ok=0
start_no=0
stop_ok=0
stop_no=0
feat_not_in_aln=0
same_pos=0

close_start=0
far_start=0
close_stop=0
far_stop=0


for feature_id in walks_grannot:
        same_start=False

        if feature_id not in feat_found_aln:
                feat_not_in_aln+=1
        else:
                best_occurence=feat_found_aln[feature_id][0]
                if len(feat_found_aln[feature_id])>1: # if there is more than one alignment for the feature
                        # find best score, then check best occurence
                        grannot_seg_list=walks_grannot[feature_id][0]
                        score_max=0
                        for occurence in feat_found_aln[feature_id]:
                                score=0
                                for segment_aln in occurence[0]: # find the occurence with the most segments in common with grannot walk
                                        if segment_aln in grannot_seg_list:
                                                score+=1
                                if score>score_max:
                                        score_max=score
                                        best_occurence=occurence # [segments,start,stop]


                for seg_aligner in walks_grannot[feature_id][0]: # check that the segments given by grannot are found by the aligner
                        if seg_aligner in best_occurence[0]:
                                seg_ok+=1
                        else:
                                seg_no+=1
                
                if (best_occurence[0][0]==walks_grannot[feature_id][0][0]) and (best_occurence[1]==walks_grannot[feature_id][1]): # first seg identical and same start
                        start_ok+=1
                        same_start=True
                else:
                        start_no+=1
                        if abs(int(best_occurence[1])-int(walks_grannot[feature_id][1]))<=10:
                                close_start+=1 #chat if not the same seg ?
                        else:
                                far_start+=1
                if (best_occurence[0][-1]==walks_grannot[feature_id][0][-1]) and (best_occurence[2]==walks_grannot[feature_id][2]): # last seg identical and same stop
                        stop_ok+=1
                        if same_start==True: # same start and same stop
                                same_pos+=1
                else:
                        stop_no+=1
                        if abs(int(best_occurence[1])-int(walks_grannot[feature_id][1]))<=10:
                                close_stop+=1 # what if not the same seg ?
                        else:
                                far_stop+=1

feat_not_in_grannot=0
for feat in feat_found_aln:
        if feat not in walks_grannot:
                feat_not_in_grannot+=1



print("\n")
print(same_pos,"features identically placed by both programs")
print(len(feat_found_aln),"features placed by the aligner")
print(feat_not_in_aln,"not placed by the aligner")
print(len(walks_grannot),"features placed by grannot")
print(feat_not_in_grannot,"not placed by grannot\n")

print(seg_ok,"segments ok,",seg_no,"segments not ok") # segments from grannot found in the gene in aligner or not
print(start_ok,"start positions identical,",start_no,"start positions different") # same start pos or not
print(stop_ok,"stop positions identical",stop_no,"stop positions different\n") # same stop pos or not

print(close_start,"start position differences smaller that 10bp,",far_start,"start positions differences bigger than 10bp") # diff entre pos start grannot et pos start minigraph, pour checker que j'ai pas un décalage de type bed/gff
print(close_stop,"stop positions differences smaller than 10bp,",far_stop,"stop positions differences bigger than 10bp") # diff entre pos stop grannot et pos stop minigraph, pour checker que j'ai pas un décalage de type bed/gff
