# transfer from nipponbare to azucena, with graphs that have either nipponbare of azucena as ref.

import sys

if not(len(sys.argv)==3) :
        print("expected input : two gff files, from transfers with graphs with two different ref genomes (nb then azu)")
        sys.exit(1)
elif (sys.argv[1]=="-h") :
    print("expected input : two gff files, from transfers with graphs with two different ref genomes (nb the azu)")
    sys.exit(1)

nb_file=sys.argv[1]
azu_file=sys.argv[2]


# TODO : handle the double transfers in one file, multicopies. for now i just keep the last copy encountered.

# build a dictionnary with the tool transfer

nb = open(nb_file,'r')
lines=nb.readlines()
nb.close()

transfer_ref_nb={}
for line in lines:
    if line.strip():
        if (line[0]!="#") and (line.split()[2]=="gene"):
            line=line.split()
            feature=line[8].split(';')[0].split('=')[1]
            chr=line[0]
            start=int(line[3])
            stop=int(line[4])
            cov=float(line[8].split(';')[-2].split('=')[1])
            id=float(line[8].split(';')[-1].split('=')[1])
            pos=list([chr,start,stop,cov,id])
            # if feature in transfer_gff:
            #     if cov+id>transfer_gff[feature][3]+transfer_gff[feature][4]:
            #         transfer_gff[feature]=pos
            # else:
            transfer_ref_nb[feature]=pos # feat_id -> [chr, start, stop, cov, seq_id]

print(len(transfer_ref_nb),"features transfered with nb ref graph")



# build a dictionnary with the annot alignements

azu = open(azu_file,'r')
lines=azu.readlines()
azu.close()

transfer_ref_azu={}
for line in lines:
    if line.strip():
        if (line[0]!="#") and (line.split()[2]=="gene"):
            line=line.split()
            feature=line[8].split(';')[0].split('=')[1]
            chr=line[0]
            start=int(line[3])
            stop=int(line[4])
            cov=float(line[8].split(';')[-2].split('=')[1])
            id=float(line[8].split(';')[-1].split('=')[1])
            pos=list([chr,start,stop,cov,id])
            # if feature in transfer_gff:
            #     if cov+id>transfer_gff[feature][3]+transfer_gff[feature][4]:
            #         transfer_gff[feature]=pos
            # else:
            transfer_ref_azu[feature]=pos # feat_id -> [chr, start, stop, cov, seq_id]


print(len(transfer_ref_azu), "features transfered with the azu ref graph")




# intersection between the two transfers :
common=list();only_nb=list();only_azu=list()
for feat_annot in transfer_ref_nb:
    if feat_annot in transfer_ref_azu:
        if feat_annot not in common:
            common.append(feat_annot)
    else:
        only_nb.append(feat_annot)

for feat_transfer in transfer_ref_azu:
    if feat_transfer in transfer_ref_nb:
        if feat_transfer not in common:
            common.append(feat_transfer)
    else:
        only_azu.append(feat_transfer)

print(len(common),"features found with both ref graph")
print(len(only_nb),"features found only with the nb transfer")
print(len(only_azu),"features found only with the azu transfer\n")


nb_cov=[]
nb_id=[]
for feat in only_nb:
    nb_cov.append(transfer_ref_nb[feat][3])
    nb_id.append(transfer_ref_nb[feat][4])
nb_meanCov=sum(nb_cov)/len(nb_cov)
nb_meanId=sum(nb_id)/len(nb_id)
print("nb ref only features mean coverage :",round(nb_meanCov,3),", nb ref only features mean sequence id :",round(nb_meanId,3))

azu_cov=[]
azu_id=[]
for feat in only_azu:
    azu_cov.append(transfer_ref_azu[feat][3])
    azu_id.append(transfer_ref_azu[feat][4])
azu_meanCov=sum(azu_cov)/len(azu_cov)
azu_meanId=sum(azu_id)/len(azu_id)
print("azu ref only features mean coverage :",round(azu_meanCov,3),", azu ref only features mean sequence id :",round(azu_meanId,3))

common_nb_cov=[]
common_nb_id=[]
common_azu_cov=[]
common_azu_id=[]
for feat in common:
    common_nb_cov.append(transfer_ref_nb[feat][3])
    common_nb_id.append(transfer_ref_nb[feat][4])
    common_azu_cov.append(transfer_ref_azu[feat][3])
    common_azu_id.append(transfer_ref_azu[feat][4])
common_nb_meanCov=sum(common_nb_cov)/len(common_nb_cov)
common_nb_meanId=sum(common_nb_id)/len(common_nb_id)
common_azu_meanCov=sum(common_azu_cov)/len(common_azu_cov)
common_azu_meanId=sum(common_azu_id)/len(common_azu_id)
print("common features mean coverage : azu",round(common_azu_meanCov,3),', nb',round(common_nb_meanCov,3))
print("common features mean sequence id : azu",round(common_azu_meanId,3),', nb',round(common_nb_meanId,3),'\n')


# common transfers
[diff_chr,same_pos,diff_pos,close,close_ish,close_ishish,not_close,dist]=[0,0,0,0,0,0,0,[]]
diff_pos_list=[]
list_diff_pos=list()
for feat in common:
    if transfer_ref_nb[feat][0]==transfer_ref_azu[feat][0]: # check if same chromosome 
        dist.append(abs(transfer_ref_nb[feat][1]-transfer_ref_azu[feat][1])+abs(transfer_ref_nb[feat][2]-transfer_ref_azu[feat][2]))
        if (transfer_ref_nb[feat][1]==transfer_ref_azu[feat][1]) & (transfer_ref_nb[feat][2]==transfer_ref_azu[feat][2]): # exact same position
            same_pos+=1
        else: 
            diff_pos+=1;diff_pos_list.append([feat,abs(transfer_ref_nb[feat][1]-transfer_ref_azu[feat][1])+abs(transfer_ref_nb[feat][2]-transfer_ref_azu[feat][2])])
            if (abs(transfer_ref_nb[feat][1]-transfer_ref_azu[feat][1])<10) & (abs(transfer_ref_nb[feat][2]-transfer_ref_azu[feat][2])<10): # start and stop close
                close+=1
            elif (abs(transfer_ref_nb[feat][1]-transfer_ref_azu[feat][1])<50) & (abs(transfer_ref_nb[feat][2]-transfer_ref_azu[feat][2])<50): # start and stop not to far
                close_ish+=1
            elif (abs(transfer_ref_nb[feat][1]-transfer_ref_azu[feat][1])<100) & (abs(transfer_ref_nb[feat][2]-transfer_ref_azu[feat][2])<100): # start and stop quite far
                close_ishish+=1
            else:
                not_close+=1

    else:
        diff_chr+=1



print(same_pos,"features are at the exact same position between the two refs")
print(diff_pos+diff_chr,"features are not in the exact same position between the two refs. Among those :")
print(close,"have their start and stop positions less than 10 bases away")
print(close_ish,"have their start and stop positions between 11 and 50 bases away")
print(close_ishish,"have their start and stop positions between 51 and 100 bases away")
print(not_close,"have their start and stop positions more that 100 bases away")
print(diff_chr,"are not on the same chromosome\n")

#print(diff_pos_list) # list of [feat_name, position difference], for all the features that are not at the same position before and after the double transfer.

