feat_dict={}
# initialize dict with all the features
with open('/home/nina/grannot/GrAnnoT/wd/data/genes/nb_allFeatures.gff3') as gff:
    print("loading gff features")
    for line in gff:
        if line.strip():
            if line[0]!="#":
                line = line.split()
                feat=line[8].split(";")[0].split("=")[1]
                if feat in feat_dict:
                    print(feat)
                feat_dict[feat]={} # dict tool_name-> [type,chr,start,stop,cov,id,tool_name]

# liftoff :
with open('/home/nina/grannot/GrAnnoT/wd/data/transfers/liftoff_NbToAzu_full.gff','r') as liftoff_gff:
    print("loading liftoff transfer")
    for line in liftoff_gff:
        if line[0]=="C":
            line=line.split()
            type_feat=line[2]
            chrom=line[0]
            start=int(line[3])
            stop=int(line[4])
            feat=line[8].split(";")[0].split("=")[1]
            if type_feat=="gene":
                cov=float(line[8].split(";")[3].split('=')[1])
                seq_id=float(line[8].split(";")[4].split('=')[1])
            else:
                cov=0
                seq_id=0
            if "liftoff" not in feat_dict[feat]:
                feat_dict[feat]["liftoff"]=[]
            feat_dict[feat]["liftoff"].append([type_feat,chrom,start,stop,cov,seq_id,'liftoff'])

# grannot :
with open('/home/nina/grannot/GrAnnoT/wd/test_data/rice_chr10/new_graph/AzucenaRS1_filter80/AzucenaRS1.gff','r') as grannot_gff:
    print("loading grannot transfer")
    for line in grannot_gff:
        line=line.split()
        type_feat=line[2]
        chrom=line[0].split('_')[0]
        start=int(line[3])
        stop=int(line[4])
        feat=line[8].split(";")[0].split("=")[1]
        cov=float(line[8].split(";")[-2].split('=')[1])
        seq_id=float(line[8].split(";")[-1].split('=')[1])
        if "grannot" not in feat_dict[feat]:
            feat_dict[feat]["grannot"]=[]
        feat_dict[feat]["grannot"].append([type_feat,chrom,start,stop,cov,seq_id,'grannot'])

# odgi : 
with open('/home/nina/soft/odgi_vg_full_graph_gff/odgi/test_odgi_full','r') as odgi_file:
    print("loading odgi transfer")
    for line in odgi_file:
        line=line.split()
        type_feat=line[4]
        chrom=line[9].split(',')[0].split('#')[2].split(":")[0].split('_')[0]
        start=int(line[9].split(',')[1])+1 # bed format
        stop=int(line[10].split(',')[1])
        feat=line[8].split(";")[0].split("=")[1]
        cov=0
        seq_id=0
        if "odgi" not in feat_dict[feat]:
            feat_dict[feat]["odgi"]=[]
        feat_dict[feat]["odgi"].append([type_feat,chrom,start,stop,cov,seq_id,'odgi'])

# vg :
with open('/home/nina/soft/odgi_vg_full_graph_gff/vg_test/nb_allFeatures_renamed_filter_vg.sam','r') as vg_sam:
    print("loading vg transfer")
    for line in vg_sam:
        if line[0]!='@':
            line=line.split()
            if line[2]!='*':
                type_feat=line[0].split(";")[-1]
                start=int(line[3])
                if line[1]!='4': # all features have a line, when the feature is not found the flag is 4 for unmapped
                    length=len(line[9])
                    stop=start+length-1
                    chrom=line[2].split("#")[2].split(":")[0].split('_')[0]
                    cov=0
                    seq_id=0
                    feat=line[0].split(";")[0].split("=")[1]
                    if "vg" not in feat_dict[feat]:
                        feat_dict[feat]["vg"]=[]
                    feat_dict[feat]["vg"].append([type_feat,chrom,start,stop,cov,seq_id,'vg'])


def abs(a,b):
    if a-b>0:
        return a-b
    else:
        return b-a

def close_pos(pos1,pos2,n): # pos = [type,chr,start,stop,cov,id,tool_name]
    if pos1[1]!=pos2[1]:
        return False
    elif abs(pos1[2],pos2[2])+abs(pos1[3],pos2[3])>n:
        return False
    else:
        return True

# feat_dict[feat]={} # dict tool_name-> [[type,chr,start,stop,cov,id,tool_name],[],[],...]
print("\ncomparing positions :")


l="liftoff"
g="grannot"
o="odgi"
v="vg"

intersection_tools={} # store intersections between tools for the upset plot (in r)

n=10 # cumulated start and stop position difference allowed to say that the annotations are close
print("position difference tolerated =",n)

# nb_print=0
nb_odgi_specific=0
nb_odgi_specific_1=0

for feat in feat_dict:
    tools=feat_dict[feat]

    # group all the occurences of the feature for all the tools
    all_tools=[]
    if o in tools:
        for occ in tools[o]:
            all_tools.append(occ)
    if v in tools:
        for occ in tools[v]:
            all_tools.append(occ)
    if g in tools:
        for occ in tools[g]:
            all_tools.append(occ)
    if l in tools:
        for occ in tools[l]:
            all_tools.append(occ)
    
    
    # group occurences. for the first one, see which tools placed the feature close in an occurence. 
    # then remove all these occurences that were grouped together. then try to group the remaining occurences (multicopy for instance)
    while len(all_tools)>0:
        feature_type=all_tools[0][0]
        current_occ=all_tools[0]
        tool_name=current_occ[-1]
        list_tool_current_feat=set() # list of tools for the current occurence
        list_tool_current_feat.add(tool_name)
        all_tools.remove(current_occ) # remove because this occurence is already treated

        other_occ_remove=[]
        for other_occ in all_tools: # look for close occurences
            if close_pos(current_occ,other_occ,n):
                list_tool_current_feat.add(other_occ[-1]) # store the tools that gave a close occurence
                other_occ_remove.append(other_occ)
        for occ_rem in other_occ_remove: # remove all the occurences used from the list
            all_tools.remove(occ_rem)

        tool_list_string="_".join(list_tool_current_feat)
        if tool_list_string not in intersection_tools: # store the info that a position is shared between these tools
            intersection_tools[tool_list_string]=0
        intersection_tools[tool_list_string]+=1

        if tool_list_string=="odgi":
            if "odgi" in feat_dict[feat]:
                nb_odgi_specific+=1
                if feat_dict[feat]["odgi"][0][3]-feat_dict[feat]["odgi"][0][2]==-1:
                    nb_odgi_specific_1+=1
                # if feat_dict[feat]["odgi"][0][3]-feat_dict[feat]["odgi"][0][2]==1:
                #     print(feat,feat_dict[feat]["odgi"])
        list_tool_current_feat=set()
        tool_list_string=""

    if list_tool_current_feat!={'vg'} and len(list_tool_current_feat)!=4 and feature_type=="gene":
        all_tools=[]
        if o in tools:
            for occ in tools[o]:
                all_tools.append(occ)
        if v in tools:
            for occ in tools[v]:
                all_tools.append(occ)
        if g in tools:
            for occ in tools[g]:
                all_tools.append(occ)
        if l in tools:
            for occ in tools[l]:
                all_tools.append(occ)

        
        # nb_print+=1
        # if nb_print>21:
        #     print(list_tool_current_feat)
        #     print(feat,all_tools)
        # if nb_print>30:
        #     exit()

print(len(feat_dict),"features in total")
print("intersections :",intersection_tools)
print("odgi specific transfers :",nb_odgi_specific,", odgi specific transfers on interval of 0 bp :",nb_odgi_specific_1)



