# get_features_liftoff_specific

from tqdm import tqdm

grannot_file_rice="/home/nina/grannot/GrAnnoT/wd/test_data/rice_chr10/test_new_graph/AzucenaRS1/AzucenaRS1.gff"
grannot_file_human="/home/nina/grannot/GrAnnoT/wd/test_data/humain/test_HG00438/HG00438#2/HG00438#2.gff"
grannot_file_ecoli="/home/nina/grannot/GrAnnoT/wd/test_data/ecoli/compare_liftoff_O127/O127_H6_E2348_69_193637c/O127_H6_E2348_69_193637c.gff"

liftoff_file_rice="/home/nina/grannot/GrAnnoT/wd/test_data/rice_chr10/test_double_transfert/liftoff_transfers/NbToAzu.gff3"
liftoff_file_human="/home/nina/grannot/GrAnnoT/wd/test_data/humain/liftoff_transfer_chm13_to_hg00438_feat_types"
liftoff_file_ecoli="/home/nina/grannot/GrAnnoT/wd/test_data/ecoli/liftoff_k12_to_0127.gff"

rice_output_file="/home/nina/grannot/GrAnnoT/wd/liftoff_spec_feat_rice.gff"
human_output_file="/home/nina/grannot/GrAnnoT/wd/liftoff_spec_feat_human.gff"
ecoli_output_file="/home/nina/grannot/GrAnnoT/wd/liftoff_spec_feat_ecoli.gff"

rice_feat_grannot={}
with open(grannot_file_rice,'r') as grannot_rice:
    for line in tqdm(grannot_rice):
        if line.split()[2]=="gene":
            feat_id=line.split()[8].split(';')[0].split('=')[1]
            rice_feat_grannot[feat_id]=''

human_feat_grannot={}
with open(grannot_file_human,'r') as grannot_human:
    for line in tqdm(grannot_human):
        last_field=len(line.split())-1
        feat_id=line.split()[last_field].split(';')[0].split('=')[1]
        human_feat_grannot[feat_id]=''

ecoli_feat_grannot={}
with open(grannot_file_ecoli,'r') as grannot_ecoli:
    for line in tqdm(grannot_ecoli):
        feat_id=line.split()[8].split(';')[0].split('=')[1]
        ecoli_feat_grannot[feat_id]=''


liftoff_feat_rice={}
liftoff_feat_human={}
liftoff_feat_ecoli={}

with open(liftoff_file_rice,'r') as liftoff_rice, open(rice_output_file,'w') as output_file:
    for line in tqdm(liftoff_rice):
        if line[0]!="#":
            feat_id=line.split()[8].split(';')[0].split('=')[1]
            if feat_id not in rice_feat_grannot:
                if line.split()[2]=="gene":
                    liftoff_feat_rice[feat_id]=''
                    output_file.write(line)

with open(liftoff_file_human,'r') as liftoff_human, open(human_output_file,'w') as output_file:
    for line in tqdm(liftoff_human):
        if line[0]!="#":
            feat_id=line.split()[8].split(';')[0].split('=')[1]
            if feat_id not in human_feat_grannot:
                liftoff_feat_human[feat_id]=''
                output_file.write(line)

with open(liftoff_file_ecoli,'r') as liftoff_ecoli, open(ecoli_output_file,'w') as output_file:
    for line in tqdm(liftoff_ecoli):
        if line[0]!="#":
            feat_id=line.split()[8].split(';')[0].split('=')[1]
            if feat_id not in ecoli_feat_grannot:
                liftoff_feat_ecoli[feat_id]=''
                output_file.write(line)

print(len(rice_feat_grannot),len(human_feat_grannot),len(ecoli_feat_grannot))
print(len(liftoff_feat_rice),len(liftoff_feat_human),len(liftoff_feat_ecoli))